function [Z,Z_pos,T,PCidx,all_nodes,basis,sums,difs,theta,all_d, C, cc]= Run_JTree(X,maxlev)

%[Z,Z_pos,T,PCidx,all_nodes,basis,sums,difs,theta,all_d, C, cc]= Run_JTree(X,maxlev)
%
% CALLS: Build_JTree.m, JTree_Basis.m, newJacobi.m
% Ann B. Lee, March 2003. Last changed, ABL: 9/23/04, 3/18/06, 4/15/08

%----------------------------------------------------
% LOAD INPUT (each row is an observation)
%----------------------------------------------------
[N,dim]=size(X);
X = X - ones(N,1)*mean(X,1);   % center the data
tmp_norm=sqrt(sum(X.*X,1));  Xnorm=X./(ones(N,1)*tmp_norm);  % normalized columns
cc=Xnorm'*Xnorm; clear Xnorm tmp_norm
C=X'*X/N;

%-----------------------------------------------------
% TREE ALGORITHM
%-----------------------------------------------------
[Z_pos, T, PCidx, all_nodes, theta, PC_ratio, Z,all_d] = Build_JTree(C,cc,maxlev);

%------------------------------------------------
% PLOT ORTHOGONAL BASIS (coarse-to-fine)
%-------------------------------------------------
[basis, sums, difs] = JTree_Basis(Z_pos,T,PCidx,maxlev,all_nodes);  
return,
